"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactSelect = _interopRequireDefault(require("react-select"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var MySelect = function MySelect(props) {
  if (props.allowSelectAll) {
    return /*#__PURE__*/_react["default"].createElement(_reactSelect["default"], _extends({}, props, {
      options: [props.allOption].concat(_toConsumableArray(props.options)),
      onChange: function onChange(selected) {
        if (selected !== null && selected.length > 0 && selected[selected.length - 1].value === props.allOption.value) {
          return props.onChange(props.options);
        }

        return props.onChange(selected);
      }
    }));
  }

  return /*#__PURE__*/_react["default"].createElement(_reactSelect["default"], props);
};

MySelect.propTypes = {
  options: _propTypes["default"].array,
  value: _propTypes["default"].any,
  onChange: _propTypes["default"].func,
  allowSelectAll: _propTypes["default"].bool,
  allOption: _propTypes["default"].shape({
    label: _propTypes["default"].string,
    value: _propTypes["default"].string
  })
};
MySelect.defaultProps = {
  allOption: {
    label: "Select all",
    value: "*"
  }
};
var _default = MySelect;
exports["default"] = _default;